"use strict";

require("core-js/modules/es.symbol");

require("core-js/modules/es.symbol.description");

require("core-js/modules/es.symbol.iterator");

require("core-js/modules/es.array.find");

require("core-js/modules/es.array.iterator");

require("core-js/modules/es.object.create");

require("core-js/modules/es.object.define-property");

require("core-js/modules/es.object.get-prototype-of");

require("core-js/modules/es.object.set-prototype-of");

require("core-js/modules/es.object.to-string");

require("core-js/modules/es.string.iterator");

require("core-js/modules/web.dom-collections.iterator");

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _enzyme = require("enzyme");

var _handler = _interopRequireDefault(require("../handler"));

var _ = _interopRequireDefault(require("."));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var defaultValues = {
  a: true
};

var Test =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Test, _React$Component);

  function Test() {
    _classCallCheck(this, Test);

    return _possibleConstructorReturn(this, _getPrototypeOf(Test).apply(this, arguments));
  }

  _createClass(Test, [{
    key: "getDefaults",
    value: function getDefaults() {
      return defaultValues;
    }
  }]);

  return Test;
}(_react["default"].Component);

describe('HOC/submit', function () {
  it('extends class-based components', function () {
    var TestHandler = (0, _["default"])((0, _handler["default"])(Test));
    expect(TestHandler.displayName).toBe('submit(handler(Test))');
    expect(function () {
      (0, _["default"])(function () {});
    }).toThrow('Cannot extend a functional component');
  });
  it("doesn't crash if used before handler", function () {
    var TestHandler = (0, _handler["default"])((0, _["default"])(Test));
    expect(function () {
      return (0, _enzyme.shallow)(_react["default"].createElement(TestHandler, null)).instance().getChildContext();
    }).not.toThrow();
  });
  it('supports isLoading() and canSubmit()', function () {
    var DefaultHandler = (0, _["default"])((0, _handler["default"])(Test));
    var childContext = (0, _enzyme.shallow)(_react["default"].createElement(DefaultHandler, null)).instance().getChildContext();
    expect(childContext.ffCanSubmit()).toBe(true);
    expect(childContext.ffIsLoading()).toBe(false);
    var SubmitHandler = (0, _["default"])((0, _handler["default"])(
    /*#__PURE__*/
    function (_Test) {
      _inherits(_class, _Test);

      function _class() {
        _classCallCheck(this, _class);

        return _possibleConstructorReturn(this, _getPrototypeOf(_class).apply(this, arguments));
      }

      _createClass(_class, [{
        key: "canSubmit",
        value: function canSubmit() {
          return false;
        }
      }]);

      return _class;
    }(Test)));
    var childContext2 = (0, _enzyme.shallow)(_react["default"].createElement(SubmitHandler, null)).instance().getChildContext();
    expect(childContext2.ffCanSubmit()).toBe(false);
    expect(childContext2.ffIsLoading()).toBe(false);
    var LoadingHandler = (0, _["default"])((0, _handler["default"])(
    /*#__PURE__*/
    function (_Test2) {
      _inherits(_class2, _Test2);

      function _class2() {
        _classCallCheck(this, _class2);

        return _possibleConstructorReturn(this, _getPrototypeOf(_class2).apply(this, arguments));
      }

      _createClass(_class2, [{
        key: "isLoading",
        value: function isLoading() {
          return true;
        }
      }]);

      return _class2;
    }(Test)));
    var childContext3 = (0, _enzyme.shallow)(_react["default"].createElement(LoadingHandler, null)).instance().getChildContext();
    expect(childContext3.ffCanSubmit()).toBe(false);
    expect(childContext3.ffIsLoading()).toBe(true);
  });
  it('adds onSubmit to the formProps()', function () {
    var FormPropsHandler = (0, _["default"])((0, _handler["default"])(Test));
    var wrapper = (0, _enzyme.shallow)(_react["default"].createElement(FormPropsHandler, null));
    expect(wrapper.find('form').props().onSubmit).toBe(wrapper.instance().onSubmitBound);
  });
  it('calls the super.onSubmit(values)', function () {
    var callCount = 0;

    var Submit =
    /*#__PURE__*/
    function (_Test3) {
      _inherits(Submit, _Test3);

      function Submit() {
        _classCallCheck(this, Submit);

        return _possibleConstructorReturn(this, _getPrototypeOf(Submit).apply(this, arguments));
      }

      _createClass(Submit, [{
        key: "onSubmit",
        value: function onSubmit(values) {
          callCount += 1;
          expect(values).toBe(defaultValues);
        }
      }]);

      return Submit;
    }(Test);

    var FormSubmit = (0, _["default"])((0, _handler["default"])(Submit));
    var wrapper = (0, _enzyme.shallow)(_react["default"].createElement(FormSubmit, null));
    var preventDefault = jest.fn();
    wrapper.find('form').simulate('submit', {
      preventDefault: preventDefault
    });
    expect(callCount).toBe(1);
    expect(preventDefault).toHaveBeenCalledTimes(1);
  });
  it('retains childContext', function () {
    var _class3, _temp;

    var FormContextHandler = (0, _["default"])((0, _handler["default"])((_temp = _class3 =
    /*#__PURE__*/
    function (_Test4) {
      _inherits(_class3, _Test4);

      function _class3() {
        _classCallCheck(this, _class3);

        return _possibleConstructorReturn(this, _getPrototypeOf(_class3).apply(this, arguments));
      }

      _createClass(_class3, [{
        key: "getChildContext",
        value: function getChildContext() {
          return {
            test: true
          };
        }
      }]);

      return _class3;
    }(Test), _defineProperty(_class3, "childContextTypes", {
      test: _propTypes["default"].bool.isRequired
    }), _temp)));
    expect(FormContextHandler.childContextTypes.test).toBe(_propTypes["default"].bool.isRequired);
    var wrapper = (0, _enzyme.shallow)(_react["default"].createElement(FormContextHandler, null));
    expect(wrapper.instance().getChildContext().test).toBe(true);
  });
});