"use strict";

require("core-js/modules/es.symbol");

require("core-js/modules/es.symbol.description");

require("core-js/modules/es.symbol.iterator");

require("core-js/modules/es.array.iterator");

require("core-js/modules/es.object.create");

require("core-js/modules/es.object.define-property");

require("core-js/modules/es.object.get-prototype-of");

require("core-js/modules/es.object.set-prototype-of");

require("core-js/modules/es.object.to-string");

require("core-js/modules/es.string.iterator");

require("core-js/modules/web.dom-collections.iterator");

var _react = _interopRequireDefault(require("react"));

var _enzyme = require("enzyme");

var _handler = _interopRequireDefault(require("../handler"));

var _ = _interopRequireDefault(require("."));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var Test =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Test, _React$Component);

  function Test() {
    _classCallCheck(this, Test);

    return _possibleConstructorReturn(this, _getPrototypeOf(Test).apply(this, arguments));
  }

  _createClass(Test, [{
    key: "getDefaults",
    value: function getDefaults() {
      return {
        a: true
      };
    }
  }]);

  return Test;
}(_react["default"].Component);

describe('HOC/valid', function () {
  it('extends class-based components', function () {
    var TestHandler = (0, _["default"])((0, _handler["default"])(Test));
    expect(TestHandler.displayName).toBe('valid(handler(Test))');
    expect(function () {
      (0, _["default"])(function () {});
    }).toThrow('Cannot extend a functional component');
  });
  it("doesn't crash if used before handler", function () {
    var TestHandler = (0, _handler["default"])((0, _["default"])(Test));
    expect(function () {
      return (0, _enzyme.shallow)(_react["default"].createElement(TestHandler, null)).instance().getChildContext();
    }).not.toThrow();
  });
  it('yields to super.canSubmit()', function () {
    var TestHandler = (0, _["default"])((0, _handler["default"])(
    /*#__PURE__*/
    function (_Test) {
      _inherits(_class, _Test);

      function _class() {
        _classCallCheck(this, _class);

        return _possibleConstructorReturn(this, _getPrototypeOf(_class).apply(this, arguments));
      }

      _createClass(_class, [{
        key: "canSubmit",
        value: function canSubmit() {
          return false;
        }
      }]);

      return _class;
    }(Test)));
    var component = (0, _enzyme.shallow)(_react["default"].createElement(TestHandler, null)).instance();
    expect(component.canSubmit()).toBe(false);
  });
  it('can submit with no validation errors', function () {
    var TestHandler = (0, _["default"])((0, _handler["default"])(Test));
    var component = (0, _enzyme.shallow)(_react["default"].createElement(TestHandler, null)).instance();
    expect(component.canSubmit()).toBe(true);
  });
  it('adds and removes validation arrays when called, and blocks sumbit accordingly', function () {
    var TestHandler = (0, _["default"])((0, _handler["default"])(Test));
    var component = (0, _enzyme.shallow)(_react["default"].createElement(TestHandler, null)).instance();

    var _component$getChildCo = component.getChildContext(),
        ffUpdateValidation = _component$getChildCo.ffUpdateValidation;

    expect(component.state.validationResults.length).toBe(0); // Handles initial mount

    ffUpdateValidation(undefined, []);
    expect(component.state.validationResults.length).toBe(0);
    ffUpdateValidation([], []);
    expect(component.state.validationResults.length).toBe(0);
    var validationResult = ['Error'];
    ffUpdateValidation([], validationResult);
    expect(component.state.validationResults.length).toBe(1); // Shouldn't be able to submit the form with validation errors

    expect(component.canSubmit()).toBe(false); // Test other components triggering their own validation

    ffUpdateValidation([], []);
    expect(component.state.validationResults.length).toBe(1);
    var otherValidationResult = ['Another error'];
    ffUpdateValidation([], otherValidationResult);
    expect(component.state.validationResults.length).toBe(2);
    expect(component.canSubmit()).toBe(false); // Begin clearing errors

    ffUpdateValidation(validationResult, []);
    expect(component.state.validationResults.length).toBe(1);
    ffUpdateValidation(otherValidationResult, []);
    expect(component.state.validationResults.length).toBe(0);
    expect(component.canSubmit()).toBe(true);
  });
});