"use strict";

require("core-js/modules/es.symbol");

require("core-js/modules/es.symbol.description");

require("core-js/modules/es.symbol.iterator");

require("core-js/modules/es.array.iterator");

require("core-js/modules/es.object.create");

require("core-js/modules/es.object.define-property");

require("core-js/modules/es.object.get-prototype-of");

require("core-js/modules/es.object.set-prototype-of");

require("core-js/modules/es.object.to-string");

require("core-js/modules/es.string.iterator");

require("core-js/modules/web.dom-collections.iterator");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.Subscription = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _utilities = require("../../utilities");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var Subscription =
/*#__PURE__*/
function () {
  function Subscription(subscriber, onChange) {
    _classCallCheck(this, Subscription);

    this.subscriber = subscriber;
    this.updateSubscriber = onChange;
  }

  _createClass(Subscription, [{
    key: "trySubscribe",
    value: function trySubscribe() {
      this.tryUnsubscribe();
      this.subscriber.context.formSubscription.subscribe(this.updateSubscriber);
    }
  }, {
    key: "tryUnsubscribe",
    value: function tryUnsubscribe() {
      this.subscriber.context.formSubscription.unsubscribe(this.updateSubscriber);
    }
  }]);

  return Subscription;
}();

exports.Subscription = Subscription;

var Subscriber =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Subscriber, _React$Component);

  function Subscriber(props, context) {
    var _this;

    _classCallCheck(this, Subscriber);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Subscriber).call(this, props, context));
    _this.state = {};
    _this.subscription = new Subscription(_assertThisInitialized(_this), function () {
      return _this.triggerUpdate();
    });
    return _this;
  }

  _createClass(Subscriber, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.subscription.trySubscribe(this.props);
    }
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps, nextState) {
      return (0, _utilities.shallowCompare)(nextProps, this.props) || (0, _utilities.shallowCompare)(nextState, this.state);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.subscription.tryUnsubscribe();
    }
  }, {
    key: "triggerUpdate",
    value: function triggerUpdate() {
      this.setState({});
    }
  }, {
    key: "render",
    value: function render() {
      return _react["default"].createElement(_react["default"].Fragment, null, this.props.children);
    }
  }]);

  return Subscriber;
}(_react["default"].Component);

exports["default"] = Subscriber;

_defineProperty(Subscriber, "propTypes", {
  children: _propTypes["default"].node
});

_defineProperty(Subscriber, "defaultProps", {
  children: null
});

_defineProperty(Subscriber, "contextTypes", {
  formSubscription: _propTypes["default"].objectOf(_propTypes["default"].func).isRequired
});